#include <locale>
#include <stdexcept> 
#include <iostream>
using namespace std;

//----------------------------------------------------------
void test00( void ) {
   locale::global( locale( "" ) );
   wcout << L"строка" << endl;
}
//----------------------------------------------------------
void test01( void ) {
   locale loc;
   try {
      loc = std::locale ( "ru_RU.utf8" );
   }
   catch( std::runtime_error ) {
      loc = std::locale ( loc, "", std::locale::ctype );
   }
   locale::global( loc ); 
   wcout << L"строка" << endl;
}
//----------------------------------------------------------
void test02( void ) {
   locale::global( locale( "" ) );
   cout << "строка1" << endl;
   wcout << L"строка2" << endl;
   cout << "строка3" << endl;
   wcout << L"строка4" << endl; 
}
//----------------------------------------------------------
void test03( void ) {
   locale::global( locale( "" ) );
   wcout << L"строка1" << endl;
   cout << "строка2" << endl;
   wcout << L"строка3" << endl;
   cout << "строка4" << endl; 
}
//----------------------------------------------------------
void test04( void ) {
   locale::global( locale( "" ) );
   stdout = freopen( "/dev/stdout", "w", stdout );
   cout << "строка c1" << endl;
   stdout = freopen( "/dev/stdout", "w", stdout );
   wcout << L"строка w2" << endl;
   stdout = freopen( "/dev/stdout", "w", stdout );
   cout << "строка c3" << endl;
   stdout = freopen( "/dev/stdout", "w", stdout );
   wcout << L"строка w4" << endl;
}
//-----------------------------------------------------
void test05( void ) {
   locale::global( locale( "" ) );
   stdout = freopen( NULL, "w", stdout );
   cout << "строка1" << endl;
   stdout = freopen( NULL, "w", stdout );
   wcout << L"строка2" << endl;
   stdout = freopen( NULL, "w", stdout );
   cout << "строка3" << endl;
   stdout = freopen( NULL, "w", stdout );
   wcout << L"строка4" << endl;
}
//-----------------------------------------------------

void ( *tests[] )( void ) = {     // последовательность тестов
        test00, test01, test02,
        test03, test04, test05,
};

static void do_test( int i ) {
   wcout << "---------------------------------------" << endl;
   tests[ i ]();
}

int main( int argc, char **argv, char **envp ) {
   locale::global( locale( "" ) );
   for( int i = 0; (unsigned)i < sizeof( tests ) / sizeof( tests[ 0 ] ); i++ ) 
      if( 1 == argc ) 
         do_test( i );
      else
         for( int j = 0; j < argc - 1; j++ ) 
            if( atoi( argv[ j + 1 ] ) == i )
               do_test( i );
   wcout << "---------------------------------------" << endl;
   return 0;
}
