#include <stdlib.h>
#include <stdio.h>
#include <wchar.h>
#include <locale.h>

#define MAX_TXT 100
int main( int argc, char *argv[] ) {
   if( argc != 2 ) {
      printf( "нужно указать имя входного файла\n" );
      return 1;
   }
   char *loc = setlocale( LC_ALL, "ru_RU.utf8" ); // char *loc = setlocale( LC_ALL, "" );
   printf( "локализация %s\n", loc );   
   FILE *fi = fopen( argv[ 1 ], "r" );
   if( !fi ) {
      printf( "ошибка открытия файла %s: %m\n", argv[ 1 ] );
      return 1;
   }
   wchar_t buf[ MAX_TXT ]; 
   do {
      if( NULL == fgetws( buf, MAX_TXT, fi ) ) { 
         if( feof( fi ) != 0 ) break;             //EOF
         printf( "ошибка чтения: %m\n" );
         return 1;
      }
      printf( "%ls", buf );
   } while( 0 == feof( fi ) );
   fclose( fi );
   return 0;
} 
